var lWarn = {logln:function (o){}};
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "sr-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

var Utf8 = {
    // public method for url encoding
    encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    }
};

function startup() {
    // Prepare app
    Property.load();
    var version = '1.0.9',
        propVersion = Property.getNode('version');
    lInfo.logln("startup scene-responder");

    if (propVersion) {
        var currentVersion = propVersion.getValue();
        if (isPropertyTreeNotCurrent(currentVersion, '0.4') < 0 ) {
            lInfo.logln("Converting from version " + currentVersion + " to 0.4");
            convertOldTriggers();
            currentVersion = '0.4';
        }
        if (isPropertyTreeNotCurrent(currentVersion, '1.0.3') < 0 ) {
            lInfo.logln("Converting from version " + currentVersion + " to 1.0.3");
            updateData();
            currentVersion = '1.0.3';
        }
        if (isPropertyTreeNotCurrent(currentVersion, '1.0.4') < 0 ) {
            lInfo.logln("Converting from version " + currentVersion + " to 1.0.4");
            updateScope();
            currentVersion = '1.0.4';
        }
        if (isPropertyTreeNotCurrent(currentVersion, '1.0.5') < 0 ) {
            lInfo.logln("Converting from version " + currentVersion + " to 1.0.5");
            updatePersistentScope();
            currentVersion = '1.0.5';
        }
        lInfo.logln("Check convertion from version " + currentVersion + " to " + version);
        if (isPropertyTreeNotCurrent(currentVersion, version) < 0 ) {
            lInfo.logln("Converting from version " + currentVersion + " to " + version);
            updateDSID2DSUID();
            currentVersion = '1.0.7';
        }
    }
    updateAllTrigger();

    if (!Property.getNode('entries')) {
        var nd = new Property('entries');
        nd.setFlag('ARCHIVE', true);
    }

    //checkAndDeleteObsoleteSREntries();

    //set version number
    Property.setProperty('version', version);
    Property.setFlag('version', 'ARCHIVE', true);
    Property.store();
    lInfo.logln("scene-responder running (Version " + version + ")");
    
}

function checkAndDeleteObsoleteSREntries() {
	var fMigrate=false;
	lInfo.logln('Checke nach SR Eintraege, die zu Apps geh�ren, die schon deinstalliert sind');
	var basePropertyArray = Property.getNode('entries');
	if (basePropertyArray!=null) {
       var subPropArray = basePropertyArray.getChildren();
       for ( var iIndex = 0; iIndex < subPropArray.length; iIndex++) {
           lInfo.logln('checkAndDeleteObsoleteSREntries values found ' + iIndex);
           if (subPropArray[iIndex].getChild('persistentScope').getValue()==false) {
               var sName=subPropArray[iIndex].getChild('scope').getValue();
               lInfo.logln('check ' + sName + " v " + Property.getNode('/scripts/'+ sName)); 
                
        	   if (Property.getNode('/scripts/'+ sName)  == null) {
        		   	lWarn.logln('Remove ' + subPropArray[iIndex].getName());
       	        	basePropertyArray.removeChild(subPropArray[iIndex].getName());       	        	
    	            unregisterTrigger(basePropertyArray.getPath() + "/" + subPropArray[iIndex].getName());
       	        	
       	        	fMigrate=true;
        	   }
           }
       }
   }
	   
   if (fMigrate)
       Property.store();
   else
       lInfo.logln('nothing to update - checkAndDeleteObsoleteSREntries');
}

function getNewIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('entries');
    if (baseNode == null) {
        return idValue;
    }
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null) {
            if (oChildNode.getChild('id').getValue() != null) {
                if (parseInt("" + oChildNode.getChild('id').getValue(), 10) >= idValue) {
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(), 10) + 1;
                }
            }
        }
    }
    return idValue;
}

function storeValue(sValue) {
    try {
        var oParameterObject = JSON.parse(unescape(sValue));

        var idValue = null;
        
        if (oParameterObject.id != null) {
        	idValue = oParameterObject.id;  
        } else {
            idValue = getNewIdValue();
        }

        var baseNode = Property.getNode('entries');
        if (baseNode != null) {
            baseNode.removeChild(idValue);
        }
        //the unescape already ensures to be string
        Property.setSavedProperty('entries/' + idValue + '/name', Utf8.encode(unescape(oParameterObject.name)));
        Property.setSavedProperty('entries/' + idValue + '/id', idValue);
        Property.setSavedProperty('entries/' + idValue + '/conditions/enabled', true);

        if (!putActionParameter('entries/' + idValue,oParameterObject)) throw "wrong argument types";
        if (!putTriggerParameter('entries/' + idValue,oParameterObject)) throw "wrong argument types";
        if (!putConditionParameter('entries/' + idValue,oParameterObject)) throw "wrong argument types";
        if (!checkAndStoreIntParameter('entries/' + idValue + '/delay', oParameterObject.delay)) throw "wrong argument types";
          
            	
        Property.setSavedProperty('entries/' + idValue + '/singularTriggered', false);
        if (oParameterObject.singularTriggered!=null)
        	if (oParameterObject.delay>0)
	            if (oParameterObject.singularTriggered) {
	            	Property.setSavedProperty('entries/' + idValue + '/singularTriggered', true);
	            }

        Property.setSavedProperty('entries/' + idValue + '/initialTriggered', false);
        if (oParameterObject.initialTriggered!=null)
        	if (oParameterObject.delay>0)
	        	if (oParameterObject.initialTriggered) {
	            	Property.setSavedProperty('entries/' + idValue + '/initialTriggered', true);
	            }
        
        if (oParameterObject.scope!=null) {
        	if (!checkAndStoreStringParameter('entries/' + idValue + '/scope',oParameterObject.scope)) throw "wrong argument types";
        } else {
        	Property.setSavedProperty('entries/' + idValue + '/scope','system-addon-scene-responder');
        }
        
        if (oParameterObject.persistentScope !=null) {
        	Property.setSavedProperty('entries/' + idValue + '/persistentScope',oParameterObject.persistentScope );
        } else {
        	Property.setSavedProperty('entries/' + idValue + '/persistentScope',true);
        }
        
        if (oParameterObject.metaData!=null) {
        	if (!checkAndStoreStringParameter('entries/' + idValue + '/metaData', oParameterObject.metaData)) throw "wrong argument types";
        }
        
        //Property.store();
        updateTriggerRegistration(Property.getNode('entries/' + idValue));
        return true;
    } catch (e) {
        lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
        	lWarn.logln(i + ': ' + e[i]);
        }
        //we could not store all data successfully so we cleanup
        baseNode.removeChild(idValue);
        return false;
    }
}

function updateAllTrigger()
{
    var baseNode = Property.getNode('entries');
    if (baseNode == null) {
        lInfo.logln("SR-Config update all trigger : no entries");
        return;
    }
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        lInfo.logln("SR-Config Set Trigger" + iIndex);
        var oChildNode = oArrayNode[iIndex];
        updateTriggerRegistration(oChildNode);
    }
}

function updateTriggerRegistration(oChildNode)
{
    var oParameter={};
    try {
    	var iDelay=0;
    	Property.getNode(oChildNode.getPath()).removeChild('damping');
    	Property.getNode(oChildNode.getPath()).removeChild('lag');
        if (oChildNode.getChild("delay")!=null) 
            if (oChildNode.getChild("delay").getValue()!=0){
            	iDelay = oChildNode.getChild("delay").getValue();
                if (oChildNode.getChild('singularTriggered')!=null)
                    if (oChildNode.getChild('singularTriggered').getValue()) {
                    	Property.setProperty(oChildNode.getPath() + '/damping/interval',iDelay);
                    	Property.setProperty(oChildNode.getPath() + '/damping/rewindTimer',true);
                    	Property.setProperty(oChildNode.getPath() + '/lag/delay',iDelay);
                    	Property.setProperty(oChildNode.getPath() + '/lag/reschedule',true);
                    	
                    	registerTrigger(oChildNode.getPath(),'action_execute',oParameter);
                        return;
                    }
                if (oChildNode.getChild('initialTriggered')!=null)
                    if (oChildNode.getChild('initialTriggered').getValue()) {
                    	Property.setProperty(oChildNode.getPath() + '/damping/interval',iDelay);
                    	Property.setProperty(oChildNode.getPath() + '/damping/rewindTimer',false);
                    	Property.setProperty(oChildNode.getPath() + '/lag/delay',iDelay);
                    	Property.setProperty(oChildNode.getPath() + '/lag/reschedule',false);

                    	registerTrigger(oChildNode.getPath(),'action_execute',oParameter);
                        return;
                    }

            }
        if (oChildNode.getChild("delay")!=null) 
            if (oChildNode.getChild("delay").getValue()!=0){
                oParameter.time = "+" + oChildNode.getChild("delay").getValue();
            }
        
        registerTrigger(oChildNode.getPath(),'action_execute',oParameter);
    } catch (e) {
        lWarn.logln("Fehler beim registerTrigger: " + e);
        for ( var i in e) {
            l.logln(i + ': ' + e[i]);
        }
    } 
}

if (raisedEvent.name == 'system-addon-scene-responder.config') {
	Property.load();
    lInfo.logln("SR-Config param action " + raisedEvent.parameter.actions);
    if (raisedEvent.parameter.actions == 'save') {
        lInfo.logln("SR-Config param value " + unescape(raisedEvent.parameter.value));
        var success = storeValue(raisedEvent.parameter.value);
        Property.store();
        var evt;
        if (success) {
        	evt = new Event("system-addon-scene-responder.saved", {complete:'success'});
        } else {
        	evt = new Event("system-addon-scene-responder.saved", {complete:'failed'});
        }
        evt.raise();
    }
    
    if (raisedEvent.parameter.actions == 'saveMultiple') {
        lInfo.logln("SR-Config param Array " + unescape(raisedEvent.parameter.value));
        var oParameterArray = JSON.parse(unescape(raisedEvent.parameter.value));
        var fSuccess=true;
        for (var iIndex=0;iIndex<oParameterArray.length;iIndex++) {
        	lInfo.logln("SR-Config param Array # " + (iIndex+1));
            if (!storeValue(escape(JSON.stringify(oParameterArray[iIndex]))))
            	fSuccess=false;
        }
        Property.store();
        if (success) {
        	evt = new Event("system-addon-scene-responder.saved", {complete:'success'});
        } else {
        	evt = new Event("system-addon-scene-responder.saved", {complete:'failed'});
        }
        evt.raise();
    }
    
    if (raisedEvent.parameter.actions == 'enable') {
        lInfo.logln("SR-Config enable value " + raisedEvent.parameter.id);

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        lWarn.logln(typeof(oIDObject));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
        	 lInfo.logln("SR-Config enable subvalue " + oIDObject[sKey] );
	        var sanityCheck = Property.getNode('entries/'+oIDObject[sKey]);
	        if (sanityCheck != null) {                
	            Property.setSavedProperty('entries/' + oIDObject[sKey] + '/conditions/enabled', true);
	        }
        }
        
        Property.store();
        var evt = new Event("system-addon-scene-responder.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'disable') {
        lInfo.logln("SR-Config disable value " + raisedEvent.parameter.id);
        
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
	        var sanityCheck = Property.getNode('entries/'+oIDObject[sKey]);
	        if (sanityCheck != null) {                
	            Property.setSavedProperty('entries/' + oIDObject[sKey] + '/conditions/enabled', false);
	        }
        }
        
        Property.store();
        var evt = new Event("system-addon-scene-responder.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'delete') {
        lInfo.logln("SR-Config delete value " + raisedEvent.parameter.id);

        
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
        	var baseNode = Property.getNode('entries');
	        if (baseNode != null) {
	            baseNode.removeChild(oIDObject[sKey]);
	            unregisterTrigger(baseNode.getPath() + "/" + oIDObject[sKey]);
	        }
        }

        Property.store();
        var evt = new Event("system-addon-scene-responder.saved", {});
        evt.raise();
    }
} else if (raisedEvent.name == 'running') {
    startup();
    var evt = new Event("system-addon-scene-responder.cleanup", {'time':'+5'});
    evt.raise();
} else if (raisedEvent.name == 'system-addon-scene-responder.cleanup') {
	checkAndDeleteObsoleteSREntries();
}

